#include "EsoCommon_Header.hpp"
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++

void t1_acs_sum(double* x, double* t1_x, int& len, double& sum_x, double& t1_sum_x)
#pragma ad indep x t1_x
#pragma ad dep sum_x t1_sum_x
{
   int i=0; 
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   double v1_2=0; 
   double t1_v1_2=0; 
   for ( i=0; i<len; i=i+1) {
      t1_v1_0=t1_sum_x; // TLM scalar memory reference
      v1_0=sum_x; // SAC scalar memory reference
      t1_v1_1=t1_x[i]; // TLM array memory reference
      v1_1=x[i]; // SAC array memory reference
      t1_v1_2=t1_v1_0+t1_v1_1; // TLM +
      v1_2=v1_0+v1_1; // SAC +
      t1_sum_x=t1_v1_2; // TLM =
      sum_x=v1_2; // SAC =
   }
}
void t1_acs_pow(double& a, double& t1_a, double& x, double& t1_x, double& v_pow, double& t1_v_pow)
#pragma ad indep a t1_a x t1_x
#pragma ad dep v_pow t1_v_pow
{
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0;
   double ret_mosc1=0;
   t1_v1_0=t1_a; // TLM scalar memory reference
   v1_0=a; // SAC scalar memory reference
   acs_pow(v1_0,x,v1_1);  // SAC pow
   t1_v1_1=x-1; acs_pow(v1_0,t1_v1_1,ret_mosc1); t1_v1_1=x*ret_mosc1*t1_v1_0+v1_1*dcc_log(v1_0)*t1_x; // TLM pow
   t1_v_pow=t1_v1_1; // TLM =
   v_pow=v1_1; // SAC =
}

void t1_acs_div(double& top_arg, double& t1_top_arg, double& bottom_arg, double& t1_bottom_arg, double& v_div, double& t1_v_div)
#pragma ad indep top_arg t1_top_arg bottom_arg t1_bottom_arg
#pragma ad dep v_div t1_v_div
{
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   double v1_2=0; 
   double t1_v1_2=0;
   double one=0;
   t1_v1_0=t1_top_arg; // TLM scalar memory reference
   v1_0=top_arg; // SAC scalar memory reference
   t1_v1_1=t1_bottom_arg; // TLM scalar memory reference
   v1_1=bottom_arg; // SAC scalar memory reference
   one=1.0;
   acs_div(one,v1_1,v1_2);
   t1_v1_2=v1_2*t1_v1_0-v1_0*v1_2*v1_2*t1_v1_1;// TLM /
   v1_2=v1_0*v1_2;
 // SAC /
   t1_v_div=t1_v1_2; // TLM =
   v_div=v1_2; // SAC =
}
void t1_acs_sqrt(double& arg, double& t1_arg, double& v_sqrt, double& t1_v_sqrt)
#pragma ad indep arg t1_arg
#pragma ad dep v_sqrt t1_v_sqrt
{
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   double one = 0;
   double ret_div = 0;
   double div_bottom_arg = 0;
   one=1.0;
   if (arg>=0){
         t1_v1_0=t1_arg; // TLM scalar memory reference
         v1_0=arg; // SAC scalar memory reference
		 acs_sqrt(v1_0, v1_1); // SAC sqrt
		 div_bottom_arg=2*v1_1;
		 acs_div(one, div_bottom_arg, ret_div);
         t1_v1_1=ret_div*t1_v1_0; // TLM sqrt
         t1_v_sqrt=t1_v1_1; // TLM =
         v_sqrt=v1_1; // SAC =
   }
   else {
         t1_v1_0=t1_arg; // TLM scalar memory reference
         v1_0=-arg; // SAC scalar memory reference
		 acs_sqrt(v1_0, v1_1); // SAC sqrt
		 div_bottom_arg=2*v1_1;
		 acs_div(one, div_bottom_arg, ret_div);
         t1_v1_1=ret_div*t1_v1_0; // TLM sqrt
         t1_v_sqrt=t1_v1_1; // TLM =
         v_sqrt=v1_1; // SAC =
   }
}
void t1_acs_ln(double& arg, double& t1_arg, double& v_ln, double& t1_v_ln)
#pragma ad indep arg t1_arg
#pragma ad dep v_ln t1_v_ln
{
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   t1_v1_0=t1_arg; // TLM scalar memory reference
   v1_0=arg; // SAC scalar memory reference
   //t1_v1_1=t1_v1_0/v1_0; // TLM log
   acs_div(t1_v1_0,v1_0,t1_v1_1);
   v1_1=dcc_log(v1_0);  // SAC log
   t1_v_ln=t1_v1_1; // TLM =
   v_ln=v1_1; // SAC =
}
void t1_acs_exp(double& arg, double& t1_arg, double& v_exp, double& t1_v_exp)
#pragma ad indep arg t1_arg
#pragma ad dep v_exp t1_v_exp
{
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   t1_v1_0=t1_arg; // TLM scalar memory reference
   v1_0=arg; // SAC scalar memory reference
   //v1_1=exp(v1_0); // SAC exp
   acs_exp(v1_0,v1_1); // SAC exp
   t1_v1_1=v1_1*t1_v1_0; // TLM exp
   t1_v_exp=t1_v1_1; // TLM =
   v_exp=v1_1; // SAC =
}
void t1_acs_tanh(double& x, double& t1_x, double& v_tanh, double& t1_v_tanh)
#pragma ad indep x t1_x
#pragma ad dep v_tanh t1_v_tanh
{
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   t1_v1_0=t1_x; // TLM scalar memory reference
   v1_0=x; // SAC scalar memory reference
   v1_0=tanh(v1_0);
   t1_v1_1=(1-v1_0*v1_0)*t1_v1_0; // TLM tan
   v1_1=v1_0; // SAC tan
   t1_v_tanh=t1_v1_1; // TLM =
   v_tanh=v1_1; // SAC =
}
